<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenner
 * Date: 21/01/14
 * Time: 15:06
 */

namespace Folha\Facade\Relatorios;


class Rescisao {
    /**
     * Verifica se os fields estão corretamente preenchidos de acordo com o relatório selecionado
     * pck 21/01/2013
     */
    public static function verificaFields() {
        switch(tk_get_field_value('REPORT_NAME')) {  //Nome do relatório
            case '':    //Nenhum relatório selecionado
                tk_abort('Nenhum relatório selecionado.');
                break;
            case 'seguro_desemprego':
			case 'seguro_desemprego_laser':
			case 'seguro_desemprego_laser_2':
                if(tk_get_field_value('DATAINICIO') == null || tk_get_field_value('DATAFINAL') == null
                    || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('TIPOMOVIMENTO') == null)
                    tk_abort('É necessário informar as Datas de Inicio e Fim da rescisão, a Modalidade de Cálculo e o Tipo de Movimento para emitir este relatório');
                break;
            //Relatórios que não possuem parâmetros obrigatórios
            case 'trct':
            case 'termo_rescisao_nao_oficial':			
                if(tk_get_field_value('TIPOESTRUTURA') == null || tk_get_field_value('NRVINCULO') == null)
                    tk_abort('É necessário informar o Vínculo e o Tipo de Estrutura do Tomador para emitir este relatório');
                break;
            case 'thrct':
            case 'tqrct':
            case 'aviso_previo_empregado':
            case 'aviso_previo_empregador':
                if(tk_get_field_value('NRVINCULO') == null)
                    tk_abort('É necessário informar o Vínculo para emitir este relatório');
            break;
            case 'avisos':
                if(tk_get_field_value('RELATORIOAVISO') == null || tk_get_field_value('DTFORMEMISSAO') == null)
                    tk_abort('É necessário informar o relatório de aviso se deseja gerar e sua Data de emissão.');
                break;
            case 'medias_rescisao_ferias':
            case 'medias_rescisao_13':
            case 'medias_rescisao_aviso_prev':
                break;
            default:
                tk_abort('Este relatório não está integrado');
        }
    }

    /**
     * Retorna os eventos para os relatórios de médias ignorar. Varia de acordo com a org.
     * @return string
     */
    public static function valorIgnoraEvento(){
        $nrOrg = \FPA::getNrorgTrabalho();
        switch($nrOrg) {
            case 1007:
                return '45,105';    //Eventos ignorados
                break;
            default:
                return '';  //Nenhum evento é ignorado
        }
    }
} 