/*******************************************************************************/
/****                          DOC.FISCAIS/ESTOQUE                          ****/
/*******************************************************************************/
/*Criao:                                                                  ****/
/*   09/06/2015 - Jefferson Gouvea                                          ****/
/*******************************************************************************/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_ETIQUETAPRODOL' AND
                 TYPE   = 'TR' 		        AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_ETIQUETAPRODOL
GO

CREATE TRIGGER LOG_ETIQUETAPRODOL
ON ETIQUETAPRODOL
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_DSREMOTEADDR   VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST   VARCHAR(15);
   DECLARE  @V_DSSERVERRDM    VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD   VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER   VARCHAR(12);
   DECLARE  @V_USUARIO        VARCHAR(40);
   DECLARE  @V_ITPESQ         VARCHAR(40);
   DECLARE  @V_DSOPERAETIQ    VARCHAR(600);
   DECLARE  @V_DTOPERAETIQ    DATETIME;
   DECLARE  @V_CDCODBARRAETIQ VARCHAR(50);

   /*VARIVEIS DO CURSOR C_CURSOR*/  
   DECLARE  @V_IDOPERAETIQ    VARCHAR(1);
   
   DECLARE  @V_CDFILIAL_OLD        VARCHAR(4);
   DECLARE  @V_CDFILDEST_OLD       VARCHAR(4);
   DECLARE  @V_CDFILLANC_OLD       VARCHAR(4);
   DECLARE  @V_NRPEDEXOL_OLD       VARCHAR(10);
   DECLARE  @V_DTPROGENPEOL_OLD    DATETIME;
   DECLARE  @V_NRLANCTONF_OLD      VARCHAR(10);
   DECLARE  @V_NRSEQITPROD_OLD     VARCHAR(4);
   DECLARE  @V_NRSEQETIQ_OLD       VARCHAR(5);
   DECLARE  @V_CDPRODUTO_OLD       VARCHAR(10);
   DECLARE  @V_QTETIQPROD_OLD      INTEGER;
   DECLARE  @V_VRPESOETIQ_OLD      FLOAT;
   DECLARE  @V_QTTOTALPRODETIQ_OLD FLOAT;
   DECLARE  @V_IDSTATUSETIQ_OLD    VARCHAR(1);
   DECLARE  @V_DSNOTAFISORIGET_OLD VARCHAR(14);

   DECLARE  @V_CDFILIAL_NEW        VARCHAR(4);
   DECLARE  @V_CDFILDEST_NEW       VARCHAR(4);
   DECLARE  @V_CDFILLANC_NEW       VARCHAR(4);
   DECLARE  @V_NRPEDEXOL_NEW       VARCHAR(10);
   DECLARE  @V_DTPROGENPEOL_NEW    DATETIME;
   DECLARE  @V_NRLANCTONF_NEW      VARCHAR(10);
   DECLARE  @V_NRSEQITPROD_NEW     VARCHAR(4);
   DECLARE  @V_NRSEQETIQ_NEW       VARCHAR(5);
   DECLARE  @V_CDPRODUTO_NEW       VARCHAR(10);
   DECLARE  @V_QTETIQPROD_NEW      INTEGER;
   DECLARE  @V_VRPESOETIQ_NEW      FLOAT;
   DECLARE  @V_QTTOTALPRODETIQ_NEW FLOAT;
   DECLARE  @V_IDSTATUSETIQ_NEW    VARCHAR(1);
   DECLARE  @V_DSNOTAFISORIGET_NEW VARCHAR(14);
BEGIN
   SET @V_IDOPERAETIQ = '0';
   SET @V_DSOPERAETIQ = '';

   EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                   @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                   @P_DSSERVERRDM = @V_DSSERVERRDM OUTPUT,
                   @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                   @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   EXEC NMUSUARIO @P_NMUSUARIO = @V_USUARIO OUTPUT;

   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDFILIAL,
         NRLANCTONF,
         NRSEQITPROD,
         NRSEQETIQ,
         CDPRODUTO,
         QTETIQPROD,
         VRPESOETIQ,
         QTTOTALPRODETIQ,
         IDSTATUSETIQ,
         CDFILDEST,
         CDFILLANC,
         NRPEDEXOL,
         DTPROGENPEOL,
         DSNOTAFISORIGET,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
     DELETED
   WHERE
     CDFILIAL+NRLANCTONF+NRSEQITPROD+NRSEQETIQ NOT IN (SELECT CDFILIAL+NRLANCTONF+NRSEQITPROD+NRSEQETIQ FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
      DELETED.CDFILIAL,
      DELETED.NRLANCTONF,
      DELETED.NRSEQITPROD,
      DELETED.NRSEQETIQ,
      DELETED.CDPRODUTO,
      DELETED.QTETIQPROD,
      DELETED.VRPESOETIQ,
      DELETED.QTTOTALPRODETIQ,
      DELETED.IDSTATUSETIQ,
      DELETED.CDFILDEST,
      DELETED.CDFILLANC,
      DELETED.NRPEDEXOL,
      DELETED.DTPROGENPEOL,
      DELETED.DSNOTAFISORIGET,
      INSERTED.CDFILIAL,
      INSERTED.NRLANCTONF,
      INSERTED.NRSEQITPROD,
      INSERTED.NRSEQETIQ,
      INSERTED.CDPRODUTO,
      INSERTED.QTETIQPROD,
      INSERTED.VRPESOETIQ,
      INSERTED.QTTOTALPRODETIQ,
      INSERTED.IDSTATUSETIQ,
      INSERTED.CDFILDEST,
      INSERTED.CDFILLANC,
      INSERTED.NRPEDEXOL,
      INSERTED.DTPROGENPEOL,
      INSERTED.DSNOTAFISORIGET
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDFILIAL  = DELETED.CDFILIAL  AND
      INSERTED.NRLANCTONF = DELETED.NRLANCTONF AND
      INSERTED.NRSEQITPROD = DELETED.NRSEQITPROD AND
      INSERTED.NRSEQETIQ    = DELETED.NRSEQETIQ
   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDFILIAL,
      NRLANCTONF,
      NRSEQITPROD,
      NRSEQETIQ,
      CDPRODUTO,
      QTETIQPROD,
      VRPESOETIQ,
      QTTOTALPRODETIQ,
      IDSTATUSETIQ,
      CDFILDEST,
      CDFILLANC,
      NRPEDEXOL,
      DTPROGENPEOL,
      DSNOTAFISORIGET
   FROM
      INSERTED
   WHERE
      CDFILIAL+NRLANCTONF+NRSEQITPROD+NRSEQETIQ NOT IN (SELECT CDFILIAL+NRLANCTONF+NRSEQITPROD+NRSEQETIQ FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_CDCODBARRAETIQ,
                                 @V_CDFILIAL_OLD,
                                 @V_NRLANCTONF_OLD,
                                 @V_NRSEQITPROD_OLD,
                                 @V_NRSEQETIQ_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_QTETIQPROD_OLD,
                                 @V_VRPESOETIQ_OLD,
                                 @V_QTTOTALPRODETIQ_OLD,
                                 @V_IDSTATUSETIQ_OLD,
                                 @V_CDFILDEST_OLD,
                                 @V_CDFILLANC_OLD,
                                 @V_NRPEDEXOL_OLD,
                                 @V_DTPROGENPEOL_OLD,
                                 @V_DSNOTAFISORIGET_OLD,

                                 @V_CDFILIAL_NEW,
                                 @V_NRLANCTONF_NEW,
                                 @V_NRSEQITPROD_NEW,
                                 @V_NRSEQETIQ_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_QTETIQPROD_NEW,
                                 @V_VRPESOETIQ_NEW,
                                 @V_QTTOTALPRODETIQ_NEW,
                                 @V_IDSTATUSETIQ_NEW,
                                 @V_CDFILDEST_NEW,
                                 @V_CDFILLANC_NEW,
                                 @V_NRPEDEXOL_NEW,
                                 @V_DTPROGENPEOL_NEW,
                                 @V_DSNOTAFISORIGET_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_IDOPERAETIQ = 'D' BEGIN

         IF @V_QTETIQPROD_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Qtde Etiq Prod=' + CONVERT(VARCHAR,@V_QTETIQPROD_OLD);
         END;

         IF @V_VRPESOETIQ_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Vr Peso Etiq=' + CONVERT(VARCHAR, @V_VRPESOETIQ_OLD);
         END;

         IF @V_QTTOTALPRODETIQ_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Qtde Total=' + CONVERT(VARCHAR, @V_QTTOTALPRODETIQ_OLD);
         END;

         IF @V_IDSTATUSETIQ_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Status=' +@V_IDSTATUSETIQ_OLD;
         END;  

         IF @V_CDFILDEST_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Fil Destino=' +@V_CDFILDEST_OLD;
         END;

         IF @V_CDFILLANC_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Fil Lanc=' +@V_CDFILLANC_OLD;
         END;

         IF @V_NRPEDEXOL_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Nr Ped=' +@V_NRPEDEXOL_OLD;
         END;

         IF @V_DSNOTAFISORIGET_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Nota Origem=' + @V_DSNOTAFISORIGET_OLD;
         END;     

         IF @V_DTPROGENPEOL_OLD IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Dt Prog=' + CONVERT(VARCHAR, @V_DTPROGENPEOL_OLD, 104);
         END;

         SET @V_IDOPERAETIQ   = '3';
         SET @V_ITPESQ = @V_CDCODBARRAETIQ;
      END
      ELSE
         IF @V_IDOPERAETIQ= 'U' /*UPDATING*/ BEGIN
            IF (ISNULL(@V_QTETIQPROD_OLD,0)        <> ISNULL(@V_QTETIQPROD_NEW,0))        OR
               (ISNULL(@V_VRPESOETIQ_OLD,0)        <> ISNULL(@V_VRPESOETIQ_NEW,0))        OR
               (ISNULL(@V_QTTOTALPRODETIQ_OLD,0)   <> ISNULL(@V_QTTOTALPRODETIQ_NEW,0))   OR
               (ISNULL(@V_IDSTATUSETIQ_OLD,' ')    <> ISNULL(@V_IDSTATUSETIQ_NEW,' '))    OR
               (ISNULL(@V_CDFILDEST_OLD,' ')       <> ISNULL(@V_CDFILDEST_NEW,' '))       OR
               (ISNULL(@V_CDFILLANC_OLD,' ')       <> ISNULL(@V_CDFILLANC_NEW,' '))       OR
               (ISNULL(@V_NRPEDEXOL_OLD,' ')       <> ISNULL(@V_NRPEDEXOL_NEW,' '))       OR
               (ISNULL(@V_DSNOTAFISORIGET_OLD,' ') <> ISNULL(@V_DSNOTAFISORIGET_NEW,' ')) OR
               (ISNULL(@V_DTPROGENPEOL_OLD,GETDATE()) <> ISNULL(@V_DTPROGENPEOL_NEW,GETDATE())) BEGIN

               SET @V_IDOPERAETIQ   = '2';
               SET @V_ITPESQ = @V_CDCODBARRAETIQ;
            END;
         END
         ELSE BEGIN
            SET @V_IDOPERAETIQ   = '1';
            SET @V_ITPESQ = @V_CDCODBARRAETIQ;
         END;
         
         IF @V_QTETIQPROD_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Qtde Etiq Prod=' + CONVERT(VARCHAR,@V_QTETIQPROD_NEW);
         END;

         IF @V_VRPESOETIQ_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Vr Peso Etiq=' + CONVERT(VARCHAR,@V_VRPESOETIQ_NEW);
         END;

         IF @V_QTTOTALPRODETIQ_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Qtde Total=' + CONVERT(VARCHAR,@V_QTTOTALPRODETIQ_NEW);
         END;

         IF @V_IDSTATUSETIQ_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Status=' +@V_IDSTATUSETIQ_NEW;
         END;

         IF @V_CDFILDEST_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Fil Destino=' +@V_CDFILDEST_NEW;
         END;

         IF @V_CDFILLANC_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Fil Lanc=' +@V_CDFILLANC_NEW;
         END;

         IF @V_NRPEDEXOL_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Nr Ped=' +@V_NRPEDEXOL_NEW;
         END;

         IF @V_DSNOTAFISORIGET_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Nota Origem=' + @V_DSNOTAFISORIGET_NEW;
         END;

         IF @V_DTPROGENPEOL_NEW IS NOT NULL BEGIN
            SET @V_DSOPERAETIQ = @V_DSOPERAETIQ + ' Dt Prog=' + CONVERT(VARCHAR, @V_DTPROGENPEOL_NEW, 104);
         END;
      END;

      IF @V_IDOPERAETIQ <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DSOPERAETIQ IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPERAETIQ = GETDATE();

               SET @V_DSOPERAETIQ = SUBSTRING(@V_DSOPERAETIQ, 1, 600);

               INSERT INTO LOGOPERAETIQ
                  (CDCODBARRAETIQ,
                   DTOPERAETIQ,
                   IDOPERAETIQ,
                   DSOPERAETIQ,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  (@V_CDCODBARRAETIQ,
                   @V_DTOPERAETIQ,
                   @V_IDOPERAETIQ,
                   @V_DSOPERAETIQ,
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);
            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_IDOPERAETIQ,
                                    @V_CDFILIAL_OLD,
                                    @V_NRLANCTONF_OLD,
                                    @V_NRSEQITPROD_OLD,
                                    @V_NRSEQETIQ_OLD,
                                    @V_CDPRODUTO_OLD,
                                    @V_QTETIQPROD_OLD,
                                    @V_VRPESOETIQ_OLD,
                                    @V_QTTOTALPRODETIQ_OLD,
                                    @V_IDSTATUSETIQ_OLD,
                                    @V_CDFILDEST_OLD,
                                    @V_CDFILLANC_OLD,
                                    @V_NRPEDEXOL_OLD,
                                    @V_DTPROGENPEOL_OLD,
                                    @V_DSNOTAFISORIGET_OLD,

                                    @V_CDFILIAL_NEW,
                                    @V_NRLANCTONF_NEW,
                                    @V_NRSEQITPROD_NEW,
                                    @V_NRSEQETIQ_NEW,
                                    @V_CDPRODUTO_NEW,
                                    @V_QTETIQPROD_NEW,
                                    @V_VRPESOETIQ_NEW,
                                    @V_QTTOTALPRODETIQ_NEW,
                                    @V_IDSTATUSETIQ_NEW,
                                    @V_CDFILDEST_NEW,
                                    @V_CDFILLANC_NEW,
                                    @V_NRPEDEXOL_NEW,
                                    @V_DTPROGENPEOL_NEW,
                                    @V_DSNOTAFISORIGET_NEW;

   
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_ETIQUETAPRODOL','5.85.xxx';
GO
